'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDnd = require('react-dnd');

var _Connect = require('./Connect');

var _Connect2 = _interopRequireDefault(_Connect);

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

var _require = require('react-matterkit');

var getTheme = _require.getTheme;

function getDropPosition(monitor, component) {
  var node = _react2['default'].findDOMNode(component);
  var br = node.getBoundingClientRect();
  var pos = monitor.getClientOffset();
  var y = (pos.y - br.top) / br.height;
  var dropPosition;

  if (y < 0.2) dropPosition = 'before';else if (y > 0.8) dropPosition = 'after';else dropPosition = 'in';

  return dropPosition;
}

var dragSource = {
  beginDrag: function beginDrag(props) {
    return { connect: props.leaf.connect };
  },
  canDrag: function canDrag(props) {
    return props.leaf.settings.draggable;
  },
  endDrag: function endDrag(props, monitor) {
    var _monitor$getDropResult = monitor.getDropResult();

    var taken = _monitor$getDropResult.taken;
    var userHandled = _monitor$getDropResult.userHandled;

    if (!userHandled && taken) {
      props.leaf.connect['delete']();
    }
  }
};

function getDropValues(props, monitor, component) {
  var dropPosition = getDropPosition(monitor, component);
  var dropTargetLeaf = props.leaf;
  var payload = monitor.getItem();
  var abort = false;

  if (payload.connect instanceof _Connect2['default']) {
    payload = payload.connect;

    if (dropTargetLeaf.connect.value === payload.value) {
      //prevent to drop a value in itself
      abort = true;
    }
  }

  return { dropPosition: dropPosition, dropTargetLeaf: dropTargetLeaf, payload: payload, abort: abort };
}

var dropTarget = {
  drop: function drop(props, monitor, component) {
    var _getDropValues = getDropValues(props, monitor, component);

    var dropPosition = _getDropValues.dropPosition;
    var dropTargetLeaf = _getDropValues.dropTargetLeaf;
    var payload = _getDropValues.payload;
    var abort = _getDropValues.abort;

    var dropResult;

    if (abort) {
      dropResult = { taken: false };
    } else {
      dropResult = dropTargetLeaf.acceptDrop(payload, dropPosition);
    }

    return dropResult;
  },

  hover: function hover(props, monitor, component) {
    var _getDropValues2 = getDropValues(props, monitor, component);

    var dropPosition = _getDropValues2.dropPosition;
    var dropTargetLeaf = _getDropValues2.dropTargetLeaf;
    var payload = _getDropValues2.payload;
    var abort = _getDropValues2.abort;

    var canDrop;

    if (abort) {
      canDrop = false;
    } else {
      canDrop = dropTargetLeaf.canDrop(payload, dropPosition);
    }
    component.setState({ dropPosition: dropPosition, canDrop: canDrop });
  }
};

var DndWrap = (function (_React$Component) {
  _inherits(DndWrap, _React$Component);

  function DndWrap(props) {
    _classCallCheck(this, _DndWrap);

    _get(Object.getPrototypeOf(_DndWrap.prototype), 'constructor', this).call(this, props);

    this.state = {
      dropPosition: undefined
    };
  }

  _createClass(DndWrap, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var isDragging = _props.isDragging;
      var isOver = _props.isOver;
      var connectDragSource = _props.connectDragSource;
      var connectDropTarget = _props.connectDropTarget;
      var _state = this.state;
      var dropPosition = _state.dropPosition;
      var canDrop = _state.canDrop;

      if (!isOver || !canDrop) {
        dropPosition = null;
      }

      return connectDropTarget(connectDragSource(_react2['default'].createElement(
        'div',
        {
          style: this.props.style,
          onMouseEnter: this.props.onMouseEnter,
          onMouseLeave: this.props.onMouseLeave,
          onClick: this.props.onClick },
        this.props.children,
        _react2['default'].createElement(DropHighlight, { pos: 'in', currPos: dropPosition }),
        _react2['default'].createElement(DropHighlight, { pos: 'before', currPos: dropPosition }),
        _react2['default'].createElement(DropHighlight, { pos: 'after', currPos: dropPosition })
      )));
    }
  }]);

  var _DndWrap = DndWrap;
  DndWrap = (0, _reactDnd.DropTarget)(function (props) {
    return props.leaf.settings.dropTargetTypes || _Config2['default'].DND_TYPE;
  }, dropTarget, function (connect, monitor) {
    return {
      connectDropTarget: connect.dropTarget(),
      isOver: monitor.isOver()
    };
  })(DndWrap) || DndWrap;
  DndWrap = (0, _reactDnd.DragSource)(_Config2['default'].DND_TYPE, dragSource, function (connect, monitor) {
    return {
      connectDragSource: connect.dragSource(),
      isDragging: monitor.isDragging()
    };
  })(DndWrap) || DndWrap;
  return DndWrap;
})(_react2['default'].Component);

exports['default'] = DndWrap;

var DropHighlight = (function (_React$Component2) {
  _inherits(DropHighlight, _React$Component2);

  function DropHighlight() {
    _classCallCheck(this, DropHighlight);

    _get(Object.getPrototypeOf(DropHighlight.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(DropHighlight, [{
    key: 'render',
    value: function render() {
      var _s;

      var _props2 = this.props;
      var pos = _props2.pos;
      var currPos = _props2.currPos;

      var isHovering = pos === currPos;

      // var styleConfig = getTheme(this).getStyle('config')

      var s = (_s = {
        pointerEvents: 'none',
        position: 'absolute',
        width: '100%',
        left: 0
      }, _defineProperty(_s, pos === 'after' ? 'bottom' : 'top', 0), _defineProperty(_s, 'height', pos === 'in' ? '100%' : '6px'), _defineProperty(_s, 'backgroundColor', '#0074D9'), _defineProperty(_s, 'opacity', isHovering ? 0.3 : 0), _s);

      return _react2['default'].createElement('div', { style: s });
    }
  }]);

  return DropHighlight;
})(_react2['default'].Component);

module.exports = exports['default'];