'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var isObject = require('lodash/lang/isObject');
var isArray = require('lodash/lang/isArray');
var Matter = require('react-matterkit');
var Button = Matter.Button;
var Slider = Matter.Slider;
var Dropdown = Matter.Dropdown;
var Checkbox = Matter.Checkbox;
var MultiTypeInput = Matter.MultiTypeInput;
var MatterInput = Matter.Input;

var Input = (function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input() {
    _classCallCheck(this, Input);

    _get(Object.getPrototypeOf(Input.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Input, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var leaf = _props.leaf;
      var key = _props.key;

      var inputProps = _objectWithoutProperties(_props, ['leaf', 'key']);

      var value = inputProps.value;
      var type = inputProps.type;
      var onChange = inputProps.onChange;

      var input = null;

      var handleChange = function handleChange(val) {
        if (typeof onChange === 'function') {
          onChange(val, leaf.connect);
        }
      };

      var createInput = function createInput(inputType) {
        var addonOnClick = inputProps.addonOnClick ? function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return inputProps.addonOnClick.apply(inputProps, [leaf.connect].concat(args));
        } : null;

        input = React.createElement(MatterInput, _extends({}, inputProps, {
          addonOnClick: addonOnClick,
          type: inputType,
          onChange: handleChange }));
      };

      var createCheckbox = function createCheckbox() {
        return input = React.createElement(Checkbox, _extends({}, inputProps, {
          onChange: handleChange }));
      };

      var createDropdown = function createDropdown() {
        return input = React.createElement(Dropdown, _extends({}, inputProps, {
          onChange: handleChange,
          options: inputProps.options.map(function (option) {
            if (typeof option === 'string') {
              option = { label: option, value: option };
            }
            if (option.onClick) {
              (function () {
                var originalClickHandler = option.onClick;
                option = _extends({}, option, {
                  onClick: function onClick(val) {
                    return originalClickHandler(val, leaf.connect);
                  }
                });
              })();
            }
            return option;
          }) }));
      };

      if (type) {
        switch (type) {
          case 'multi':
            input = React.createElement(MultiTypeInput, _extends({}, inputProps, {
              onChange: handleChange }));
            break;
          case 'dropdown':
            createDropdown();
            break;
          case 'checkbox':
            createCheckbox();
            break;
          case 'slider':
            input = React.createElement(Slider, _extends({}, inputProps, {
              onChange: handleChange }));
            break;
          case 'number':
            createInput('number');
            break;
          case 'string':
            createInput('string');
            break;
          case 'color':
            createInput('string');
            break;
          default:
            console.warn('Unknown type: "' + type + '"');
        }
      } else {
        if (!isObject(value)) {
          if (isArray(inputProps.options)) {
            createDropdown();
          } else {
            switch (typeof value) {
              case 'function':
                input = React.createElement(Button, {
                  icon: icon,
                  label: inputProps.label || value.name || 'Button',
                  onClick: value });
                break;
              case 'number':
                createInput('number');
                break;
              case 'string':
                createInput('string');
                break;
              case 'boolean':
                createCheckbox();
                break;

            }
          }
        }
      }

      return input ? React.createElement(
        'span',
        { style: { flex: 1 }, key: key },
        input
      ) : React.createElement('span', { hidden: true, key: key });
    }
  }]);

  return Input;
})(React.Component);

exports['default'] = Input;
module.exports = exports['default'];