'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var has = require('lodash/object/has');
var Row = require('./Row');
var Matter = require('react-matterkit');
var Icon = Matter.Icon;

var Item = (function (_React$Component) {
  _inherits(Item, _React$Component);

  function Item(props) {
    var _this = this;

    _classCallCheck(this, Item);

    _get(Object.getPrototypeOf(Item.prototype), 'constructor', this).call(this, props);

    this.handleClickOpenToggle = function () {
      var leaf = _this.props.leaf;

      if (leaf.settings.onToggleOpen) {
        leaf.settings.onToggleOpen(leaf.connect);
      }

      _this.setState({ open: !_this.state.open });
    };

    this.state = { open: true };

    var settings = props.leaf.settings;

    if (has(settings, 'open')) {
      this.state.open = settings.open;
    } else if (has(settings, 'defaultOpen')) {
      this.state.open = settings.defaultOpen;
    }
  }

  _createClass(Item, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextState.open !== this.state.open;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.props.leaf.onUpdate = function () {
        return _this2.forceUpdate();
      };
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.props.leaf.onUpdate = null;
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren() {
      var _props$leaf = this.props.leaf;
      var settings = _props$leaf.settings;
      var childLeafs = _props$leaf.childLeafs;

      if (!this.state.open || childLeafs.length === 0) {
        return null;
      }

      var marginLeft = settings.hiddenHead ? 0 : has(settings, 'indent') ? settings.indent : 6;
      return React.createElement(
        'div',
        { style: { marginLeft: marginLeft } },
        childLeafs.map(function (childLeaf) {
          return childLeaf.getComponent();
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props$leaf2 = this.props.leaf;
      var settings = _props$leaf2.settings;
      var childLeafs = _props$leaf2.childLeafs;

      var _ref = has(settings, 'open') ? settings : this.state;

      var open = _ref.open;

      if (settings.ItemComponent) {
        return React.createElement(settings.ItemComponent, this.props);
      }

      var row = settings.hiddenHead ? null : React.createElement(Row, {
        leaf: this.props.leaf,
        open: open,
        hasChildren: childLeafs.length !== 0,
        onClickOpenToggle: this.handleClickOpenToggle });

      return React.createElement(
        'div',
        {
          hidden: settings.hidden,
          style: { position: 'relative' } },
        row,
        this.renderChildren()
      );
    }
  }]);

  return Item;
})(React.Component);

exports['default'] = Item;
module.exports = exports['default'];