'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _lodashObjectKeysIn = require('lodash/object/keysIn');

var _lodashObjectKeysIn2 = _interopRequireDefault(_lodashObjectKeysIn);

var _lodashLangIsObject = require('lodash/lang/isObject');

var _lodashLangIsObject2 = _interopRequireDefault(_lodashLangIsObject);

var _lodashLangIsArray = require('lodash/lang/isArray');

var _lodashLangIsArray2 = _interopRequireDefault(_lodashLangIsArray);

var _lodashLangIsFinite = require('lodash/lang/isFinite');

var _lodashLangIsFinite2 = _interopRequireDefault(_lodashLangIsFinite);

var _lodashCollectionIncludes = require('lodash/collection/includes');

var _lodashCollectionIncludes2 = _interopRequireDefault(_lodashCollectionIncludes);

var _Connect = require('./Connect');

var _Connect2 = _interopRequireDefault(_Connect);

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var Leaf = (function () {
  function Leaf(path, root, idx, parentLeaf) {
    var _this = this;

    _classCallCheck(this, Leaf);

    this.update = function (value) {
      var connect = _this.connect;
      var parentLeaf = _this.parentLeaf;
      var settings = _this.settings;
      var root = _this.root;

      if (settings.mutateValue) {
        if (parentLeaf && parentLeaf.settings.children) {
          //if the children of the parentLeaf set by the settings modify there
          parentLeaf.settings.children[connect.key] = value;
        } else {
          connect.parent[connect.key] = value;
        }

        root.reportChange();
      }

      _this._callOnChangeHandler(value);
    };

    this['delete'] = function () {
      var connect = _this.connect;
      var parentLeaf = _this.parentLeaf;
      var settings = _this.settings;
      var root = _this.root;

      if (settings.mutateValue) {
        if (parentLeaf && parentLeaf.settings.children) {
          //if the children of the parentLeaf set by the settings modify there
          delete parentLeaf.settings.children[connect.key];
        } else {
          delete connect.parent[connect.key];
        }

        root.reportChange();
      }
    };

    this.childLeafs = [];
    this.root = root;
    this.idx = idx;
    this.parentLeaf = parentLeaf;

    this.setup(path);
  }

  _createClass(Leaf, [{
    key: 'setup',
    value: function setup(nextPath) {
      var _this2 = this;

      var nextConnect = new _Connect2['default'](nextPath, this.update, this['delete'], function () {
        return _this2.root.reportChange();
      });

      if (this.settings && this.settings.shouldUpdate && this.settings.shouldUpdate(this.connect, nextConnect) === false) {
        return;
      }

      this.path = nextPath;
      this.connect = nextConnect;
      var nextSettings = this.root.getSettings(nextPath);
      var settingsChanged = !this.root.matchSettings(nextSettings, this.settings);

      if (settingsChanged) {
        this.settings = nextSettings;
      } else {
        //children aren't really tested for matching because child leafs will do
        //that and this leaf only care about the count of the them
        //so the next children have to be taken no matter what
        this.settings.children = nextSettings.children;
      }

      var childCountChanged = this.setupChildren();

      if (childCountChanged || settingsChanged) {
        if (this.onUpdate) {
          this.onUpdate();
        }
      }
    }
  }, {
    key: 'setupChildren',
    value: function setupChildren() {
      var _this3 = this;

      var settings = this.settings;
      var childLeafs = this.childLeafs;
      var path = this.path;

      var value = this.path[this.path.length - 1];
      var children;
      var childCountChanged = false;

      if (settings.children !== undefined) {
        children = settings.children;
      } else if ((0, _lodashLangIsObject2['default'])(value)) {
        children = value;
      } else {
        children = [];
      }

      var keys;
      if ((0, _lodashLangIsArray2['default'])(children)) {
        keys = Object.keys(children);
      } else if ((0, _lodashLangIsObject2['default'])(children)) {
        keys = getKeysInOrder(children, settings);
        keys = applyWhiteAndBlacklist(keys, settings);
      } else {
        keys = [];
      }

      if (childLeafs.length > keys.length) {
        // let extraLeafs =
        childLeafs.splice(keys.length);
        // extraLeafs.forEach(childLeaf => childLeaf.dispose())
        childCountChanged = true;
      }

      keys.forEach(function (key, idx) {
        var childPath = path.concat([key, children[key]]);

        if (childLeafs[idx]) {
          childLeafs[idx].setup(childPath);
        } else {
          childLeafs[idx] = new Leaf(childPath, _this3.root, idx, _this3);
          childCountChanged = true;
        }
      });

      return childCountChanged;
    }
  }, {
    key: '_callOnChangeHandler',
    value: function _callOnChangeHandler(value) {
      var settings = this.settings;
      var connect = this.connect;

      var onChange = settings.input && settings.input.onChange;
      if (typeof onChange === 'function') {
        onChange(value, connect);
      }
    }
  }, {
    key: 'acceptDrop',
    value: function acceptDrop(payload, dropPosition) {
      var connect = this.connect;
      var idx = this.idx;
      var settings = this.settings;
      var parentLeaf = this.parentLeaf;

      var taken = false;
      var userHandled = false;
      var dragSourceConnect;

      if (payload instanceof _Connect2['default']) {
        dragSourceConnect = payload;
      }

      if (dropPosition === 'before' || dropPosition === 'after') {
        if (settings.acceptDropAround) {
          taken = settings.acceptDropAround(payload, connect, parentLeaf.connect, dropPosition);

          userHandled = true;
        } else if (parentLeaf) {
          var parentDropPosition = idx;
          if (dropPosition === 'after') {
            ++parentDropPosition;
          }
          //return the dropResult of the parentLeaf
          return parentLeaf.acceptDrop(payload, parentDropPosition);
        }
      } else if (dropPosition === 'in' || (0, _lodashLangIsFinite2['default'])(dropPosition)) {
        if (settings.acceptDrop) {
          //acceptDrop should returns true if it takes the dragSource
          taken = settings.acceptDrop(payload, connect, dropPosition);
          userHandled = true;
        } else if (dragSourceConnect) {
          if ((0, _lodashLangIsArray2['default'])(connect.value)) {
            this.connect.value.splice(dropPosition, 0, dragSourceConnect.value);
            taken = true;
          } else if (typeof connect.value === 'object') {
            connect.value[dragSourceConnect.key] = dragSourceConnect.value;
            taken = true;
          } else {
            connect.value = dragSourceConnect.value;
            taken = true;
          }
        }
      }

      return { taken: taken, userHandled: userHandled };
    }
  }, {
    key: 'canDrop',
    value: function canDrop(payload, dropPosition) {
      var connect = this.connect;
      var idx = this.idx;
      var settings = this.settings;
      var parentLeaf = this.parentLeaf;

      var canDrop = true;

      if (dropPosition === 'before' || dropPosition === 'after') {
        if (settings.canDropAround) {
          canDrop = settings.canDropAround(payload, connect, parentLeaf.connect, dropPosition);
        } else if (parentLeaf) {
          var parentDropPosition = idx;
          if (dropPosition === 'after') {
            ++parentDropPosition;
          }
          canDrop = parentLeaf.canDrop(payload, parentDropPosition);
        }
      } else if (dropPosition === 'in' || (0, _lodashLangIsFinite2['default'])(dropPosition)) {
        if (settings.canDrop) {
          canDrop = settings.canDrop(payload, connect, dropPosition);
        }
      }

      return canDrop;
    }
  }, {
    key: 'getComponent',
    value: function getComponent() {
      if (!this._component) {
        //hack until React@0.14
        this._component = _react2['default'].createElement(_Item2['default'], { key: this.idx, leaf: this });
      }
      return this._component;
    }
  }]);

  return Leaf;
})();

exports['default'] = Leaf;

function getKeysInOrder(children, settings) {
  var order = settings.order;
  var includeInheriteds = settings.includeInheriteds;

  var keys = includeInheriteds ? (0, _lodashObjectKeysIn2['default'])(children) : Object.keys(children);

  if (!order) {
    return keys;
  }

  var l = keys.length - 1;
  return keys.sort(function (a, b) {
    var aIdx = order.indexOf(a);
    var bIdx = order.indexOf(b);

    if (aIdx !== -1) aIdx = l - aIdx;
    if (bIdx !== -1) bIdx = l - bIdx;

    return bIdx - aIdx;
  });
}

function applyWhiteAndBlacklist(keys, settings) {
  var whitelist = settings.whitelist;
  var blacklist = settings.blacklist;

  if (!whitelist && !blacklist) {
    return keys;
  }

  return keys.filter(function (key) {
    if (whitelist && !(0, _lodashCollectionIncludes2['default'])(whitelist, key)) return false;
    if (blacklist && (0, _lodashCollectionIncludes2['default'])(blacklist, key)) return false;
    return true;
  });
}
module.exports = exports['default'];