'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObjectAssign = require('lodash/object/assign');

var _lodashObjectAssign2 = _interopRequireDefault(_lodashObjectAssign);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _Buttons = require('./Buttons');

var _Buttons2 = _interopRequireDefault(_Buttons);

var _DndWrap = require('./DndWrap');

var _DndWrap2 = _interopRequireDefault(_DndWrap);

var _ContextMenuWrap = require('./ContextMenuWrap');

var _ContextMenuWrap2 = _interopRequireDefault(_ContextMenuWrap);

var _reactMatterkit = require('react-matterkit');

var Row = (function (_React$Component) {
  _inherits(Row, _React$Component);

  // eslint-disable-line no-shadow

  function Row(props) {
    _classCallCheck(this, Row);

    _get(Object.getPrototypeOf(Row.prototype), 'constructor', this).call(this, props);

    this.state = {
      hover: false
    };
  }

  _createClass(Row, [{
    key: 'render',
    value: function render() {
      var _this = this;

      var _props = this.props;
      var leaf = _props.leaf;
      var open = _props.open;
      var hasChildren = _props.hasChildren;
      var onClickOpenToggle = _props.onClickOpenToggle;
      var settings = leaf.settings;
      var hover = this.state.hover;

      if (settings.Component) {
        return _react2['default'].createElement(settings.Component, this.props);
      }

      var styleConfig = (0, _reactMatterkit.getTheme)(this).getStyle('config');
      var textColor = settings.highlighted ? styleConfig.palette.grey4 : styleConfig.fontColor.normal;

      var styleBlock = {
        position: 'relative',
        height: styleConfig.lineHeight,
        lineHeight: styleConfig.lineHeight + 'px',
        display: 'flex',
        color: settings.highlighted ? styleConfig.palette.blue : styleConfig.palette.grey2,
        fontSize: '13px',
        backgroundColor: settings.highlighted ? styleConfig.palette.blue : styleConfig.palette.bg,
        borderBottom: 'solid 1px #1a1d21',
        boxSizing: 'border-box'
      };

      var items = {};

      //label
      if (settings.label) {
        var styleLabel = (0, _lodashObjectAssign2['default'])({
          flex: 1,
          color: textColor
        }, // color: dropState.isDragging ? style.palette.purple : 'inherit',
        // backgroundColor: dropState.isHovering ? style.palette.blue : 'inherit',
        settings.labelStyle);

        items.label = _react2['default'].createElement(
          _reactMatterkit.Label,
          { style: styleLabel },
          settings.label
        );
      }

      //input
      items.input = _react2['default'].createElement(_Input2['default'], _extends({}, settings.input, {
        leaf: leaf,
        onChange: function (value) {
          return leaf.update(value);
        } }));

      //extraInputs
      if (settings.extraInputs) {

        items.extraInputs = _react2['default'].createElement(
          'span',
          { style: { display: 'flex', flex: 1 } },
          settings.extraInputs.map(function (inputProps, idx) {
            return _react2['default'].createElement(_Input2['default'], _extends({
              key: idx
            }, inputProps, {
              leaf: leaf }));
          })
        );
      }

      //buttons
      if (settings.buttons) {
        items.buttons = _react2['default'].createElement(_Buttons2['default'], {
          hover: hover,
          leaf: leaf,
          buttonStyle: { color: textColor },
          buttons: settings.buttons });
      }

      //show/hide toggle btn
      items.toggle = _react2['default'].createElement(_reactMatterkit.Icon, {
        icon: hasChildren ? open ? 'chevron-down' : 'chevron-right' : ' ',
        onClick: hasChildren ? onClickOpenToggle : null,
        style: { margin: '0 4px', color: textColor } });

      return _react2['default'].createElement(
        _ContextMenuWrap2['default'],
        { options: settings.contextMenu, leaf: leaf },
        _react2['default'].createElement(
          _DndWrap2['default'],
          {
            style: styleBlock,
            onMouseEnter: function () {
              return _this.setState({ hover: true });
            },
            onMouseLeave: function () {
              return _this.setState({ hover: false });
            },
            onClick: function () {
              if (settings.onClick) {
                settings.onClick(leaf.connect);
              }
            },
            leaf: leaf,
            draggable: settings.draggable },
          items.toggle,
          items.label,
          items.input,
          items.extraInputs,
          items.buttons
        )
      );
    }
  }], [{
    key: 'contextTypes',
    value: {
      matterkitTheme: _react2['default'].PropTypes.object
    },
    enumerable: true
  }]);

  return Row;
})(_react2['default'].Component);

exports['default'] = Row;
module.exports = exports['default'];