'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _settingsModel = require('./settingsModel');

var inputShape = {
  value: (0, _settingsModel.primitive)(),
  disabled: (0, _settingsModel.primitive)(),
  draggable: (0, _settingsModel.primitive)(),
  precision: (0, _settingsModel.primitive)(),
  dragSpeed: (0, _settingsModel.primitive)(),
  type: (0, _settingsModel.primitive)(),
  min: (0, _settingsModel.primitive)(),
  max: (0, _settingsModel.primitive)(),
  hints: (0, _settingsModel.arrayOf)((0, _settingsModel.primitive)()),
  label: (0, _settingsModel.primitive)(),
  options: (0, _settingsModel.arrayOf)((0, _settingsModel.primitive)()),
  maxVisibleHints: (0, _settingsModel.primitive)(),
  mod: (0, _settingsModel.objectOf)((0, _settingsModel.primitive)()),
  onChange: (0, _settingsModel.func)(),
  prepareExportValue: (0, _settingsModel.func)(),
  formatValue: (0, _settingsModel.func)(),
  prettifyValue: (0, _settingsModel.func)(),
  getElement: (0, _settingsModel.func)(),
  style: (0, _settingsModel.objectOf)((0, _settingsModel.primitive)()),

  addonIcon: (0, _settingsModel.primitive)(),
  addonLabel: (0, _settingsModel.primitive)(),
  addonBackground: (0, _settingsModel.primitive)(),
  addonOnClick: (0, _settingsModel.func)(),

  acceptValue: (0, _settingsModel.func)()
};

var simpleInput = (0, _settingsModel.object)(_extends({}, inputShape));
var input = (0, _settingsModel.object)(_extends({}, inputShape, { types: (0, _settingsModel.arrayOf)(simpleInput) }));

exports['default'] = (0, _settingsModel.memorize)((0, _settingsModel.object)({
  shouldUpdate: (0, _settingsModel.func)(),
  hidden: (0, _settingsModel.primitive)(),
  hiddenHead: (0, _settingsModel.primitive)(),
  children: (0, _settingsModel.primitive)(),
  mutateValue: (0, _settingsModel.primitive)(), //boolean
  includeInheriteds: (0, _settingsModel.primitive)(), //boolean
  highlighted: (0, _settingsModel.primitive)(),
  label: (0, _settingsModel.primitive)(),
  labelStyle: (0, _settingsModel.objectOf)((0, _settingsModel.primitive)()),
  draggable: (0, _settingsModel.primitive)(), //boolean
  whitelist: (0, _settingsModel.arrayOf)((0, _settingsModel.primitive)()),
  blacklist: (0, _settingsModel.arrayOf)((0, _settingsModel.primitive)()),
  order: (0, _settingsModel.arrayOf)((0, _settingsModel.primitive)()),
  onClick: (0, _settingsModel.func)(),
  canDrop: (0, _settingsModel.func)(), //(targetUtils, itemUtils, idx) => {},
  acceptDrop: (0, _settingsModel.func)(), //(targetUtils, itemUtils, idx) => {},
  getDragPreview: (0, _settingsModel.func)(), //connect => connect.value.getClonedDOMNode(),
  Component: (0, _settingsModel.func)(), //ReactComponent //use custom component
  input: input,
  extraInputs: (0, _settingsModel.arrayOf)(input),
  buttons: (0, _settingsModel.arrayOf)((0, _settingsModel.object)({
    mod: (0, _settingsModel.objectOf)((0, _settingsModel.primitive)()),
    label: (0, _settingsModel.primitive)(),
    icon: (0, _settingsModel.primitive)(),
    onClick: (0, _settingsModel.func)(),
    hideWhenLeaved: (0, _settingsModel.primitive)(),
    getElement: (0, _settingsModel.func)(),
    style: (0, _settingsModel.objectOf)((0, _settingsModel.primitive)())
  })),
  contextMenu: (0, _settingsModel.object)({
    items: (0, _settingsModel.arrayOf)((0, _settingsModel.primitive)()),
    renderContent: (0, _settingsModel.func)()
  })
}));
module.exports = exports['default'];