'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getSettings;
var includes = require('lodash/collection/includes');
var isArray = require('lodash/lang/isArray');
var isObject = require('lodash/lang/isObject');
var minimatch = require('minimatch');
var Connect = require('./Connect');

function getSettings(settingsList, settingsModel, path) {
  // var __t = window.performance.now()
  var connect = new Connect(path);
  var settings = {
    input: {
      value: connect.value
    },
    label: connect.key
  };

  checkSettingsList(settingsList, []);
  // window.GET_SETTINGSTIME = window.GET_SETTINGSTIME || 0
  // window.GET_SETTINGSTIME += window.performance.now() - __t
  return settings;

  function checkSettingsNode(_x, _x2, _x3) {
    var _again = true;

    _function: while (_again) {
      var settingsNode = _x,
          path = _x2,
          preselectors = _x3;
      match = selectorType = selector = selectorType = selector = selectorType = selector = newSettingsNode = newPath = newPreselectors = undefined;

      var setMatch = function setMatch(selectorType, selector) {
        var connect = new Connect(path);

        if (selectorType === 'function') {
          match = selector(connect);
        } else if (selectorType === 'select') {
          if (selector === 'all') {
            match = true;
          } else if (selector === 'root') {
            match = path.length === 2;
          } else {
            throw Error('[json-vision] unknown select command: ' + selector);
          }
        } else if (selectorType === 'instanceOf') {

          if (isArray(selector)) {
            match = selector.some(function (s) {
              return connect.value instanceof s;
            });
          } else {
            match = connect.value instanceof selector;
          }
        } else if (selectorType === 'key') {

          if (isArray(selector)) {
            match = includes(selector, connect.key);
          } else {
            match = connect.key === selector;
          }
        } else if (selectorType === 'value') {

          match = connect.value === selector;
        } else if (selectorType === 'path') {} else if (selectorType === 'regexp') {} else if (selectorType === 'glob') {

          match = minimatch(connect.fullPath, selector);
        } else {
          throw Error();
        }
      };

      _again = false;

      var match = false;

      if (typeof settingsNode.selector === 'function') {
        var selectorType = 'function';
        var selector = settingsNode.selector;
        setMatch(selectorType, selector);
      } else if (typeof settingsNode.selector === 'string') {
        var selectorType = 'select';
        var selector = settingsNode.selector;
        setMatch(selectorType, selector);
      } else if (typeof settingsNode.selector === 'object') {
        var selectorType = Object.keys(settingsNode.selector)[0];
        var selector = settingsNode.selector[selectorType];
        setMatch(selectorType, selector);
      }
      // else {
      //   match = true
      // }

      if (match) {

        if (preselectors.length === 0) {
          return true;
        } else {
          var newSettingsNode = preselectors[0];
          var newPath = path.slice(0, path.length - 2);
          var newPreselectors = preselectors.slice(1);

          _x = newSettingsNode;
          _x2 = newPath;
          _x3 = newPreselectors;
          _again = true;
          continue _function;
        }
      }
    }
  }

  function checkSettingsList(settingsList, preselectors) {

    settingsList.forEach(function (settingsNode) {

      if (typeof settingsNode === 'function') {
        settingsNode = settingsNode(connect);
      }

      if (!isObject(settingsNode)) {
        return;
      }

      if (checkSettingsNode(settingsNode, path, preselectors)) {
        settingsModel.merge(settings, settingsNode, connect);
      }

      if (settingsNode.settings) {

        var newPreselectors = [settingsNode].concat(preselectors);
        checkSettingsList(settingsNode.settings, newPreselectors);
      }
    });
  }
}

module.exports = exports['default'];