'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = arrayOf;

function arrayOf(model) {
  return {
    getMatcher: function getMatcher() {
      var matcher = model.getMatcher();

      return function (a, b) {
        if (typeof a !== 'object' || a === null || a.length === undefined || typeof b !== 'object' || b === null || b.length === undefined) {
          return a === b;
        }

        if (a.length !== b.length) {
          return false;
        }

        for (var i = 0, l = a.length; i < l; ++i) {
          if (!matcher(a[i], b[i])) {
            return false;
          }
        }

        return true;
      };
    },

    getMerger: function getMerger() {
      var merger = model.getMerger();

      return function (a, b, connect) {
        if (!a) {
          a = [];
        }

        if (typeof b === 'function') {
          b = b(connect);
        }

        if (b === null) {
          return b;
        }

        if (b) {
          for (var i = 0, l = b.length; i < l; ++i) {
            a.push(merger(null, b[i], connect));
          }
        }

        return a;
      };
    }
  };
}

module.exports = exports['default'];