'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = object;

function object(props) {
  var keys = Object.keys(props);
  var keysLength = keys.length;

  return {
    getMatcher: function getMatcher() {
      var matchers = keys.map(function (key) {
        return props[key].getMatcher();
      });

      return function (a, b) {
        var aType = typeof a;
        var bType = typeof b;

        if (aType !== bType) {
          return false;
        }

        if (aType !== 'object' || a === null || b === null) {
          return a === b;
        }

        for (var i = 0; i < keysLength; i++) {
          var key = keys[i];
          if (!matchers[i](a[key], b[key])) {
            return false;
          }
        }
        return true;
      };
    },

    getMerger: function getMerger() {
      var mergers = keys.map(function (key) {
        return props[key].getMerger();
      });

      return function (a, b, connect) {
        if (typeof b === 'function') {
          b = b(connect);
        }

        if (!a || typeof a !== 'object') {
          a = {};
        }

        if (b === null) {
          return b;
        }

        for (var i = 0; i < keysLength; i++) {
          var key = keys[i];
          var aValue = a[key];
          var bValue = b[key];

          if (bValue !== undefined) {
            a[key] = mergers[i](aValue, bValue, connect);
          }
        }
        return a;
      };
    }
  };
}

module.exports = exports['default'];